﻿//B.Stockhaus@Labor Online-Learning
//3.1.2006
//
//klasse gehört zum symbol 'InfoClip' in der library bereitet infos visuell auf.
//einige der funktionen dieser klasse werden aus der timeline des clips aufgerufen.
//**************************************************************************************

class InfoClip extends MovieClip
{
	//vars
	private var audio_source:String;//aus AudioPlayer.xml
	private var audio_textLink:String;
	private var audio_javascriptFunction:String;
	private var audio_title:String;
	private var audio_textWinWidth:Number;
	private var audio_textWinHeight:Number;
	
	private var TEXT_WIN_WIDTH:Number;
	private var TEXT_WIN_HEIGHT:Number;
	private var INIT_WIDTH:Number;
	
	//clips
	private var bg_info_mc:MovieClip;
	private var closeInfo_mc:MovieClip;
	private var downloadLink_mc:MovieClip;
	private var textLink_mc:MovieClip;
	
	private var ticker_txt:TextField;
	
	public function InfoClip()
	{
		//trace("new InfoClip")
		TEXT_WIN_WIDTH=400;
		TEXT_WIN_HEIGHT=400;
		INIT_WIDTH=this._width;
	};
	
	public function init(audio_source:String, audio_title:String, audio_textLink:String, audio_javascriptFunction:String, audio_textWinWidth:Number, audio_textWinHeight:Number):Void
	{
		this.audio_source=audio_source;
		this.audio_title=audio_title;
		this.audio_textLink=audio_textLink;
		this.audio_javascriptFunction=audio_javascriptFunction;
		this.audio_textWinWidth=audio_textWinWidth;
		this.audio_textWinHeight=audio_textWinHeight;
		
		downloadLink_mc.onRelease=function(){_parent.downloadFile();};
		downloadLink_mc.onRollOut=function(){_parent.checkRollOutActiveArea();};//prüfen, ob rollOver 'closeInfo_mc'
		textLink_mc.onRelease=function(){_parent.showText();};
		textLink_mc.onRollOut=function(){_parent.checkRollOutActiveArea();};//prüfen, ob rollOver 'closeInfo_mc'
		
		closeInfo_mc.onRollOver=function(){this.useHandCursor=false;};
		closeInfo_mc.onRollOut=function(){_parent.checkRollOutLinks();};//prüfen, ob rollOver 'downloadLink_mc' oder 'textLink_mc'
		
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//onLoad-implementierung des Mcs
	public function onLoad():Void
	{
		//default
		downloadLink_mc._visible=false;
		textLink_mc._visible=false;
		
		this.gotoAndPlay("over");
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//clip wieder entfernen
	public function checkRollOutLinks():Void
	{
		if( !downloadLink_mc.hitTest(_root._xmouse, _root._ymouse, false) &&
			!textLink_mc.hitTest(_root._xmouse, _root._ymouse, false) )
			this.gotoAndPlay("hideInfo");
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//clip wieder entfernen
	public function checkRollOutActiveArea():Void
	{
		if( !closeInfo_mc.hitTest(_root._xmouse, _root._ymouse, false) )
			this.gotoAndPlay("hideInfo");
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//mp3-datei zum download anbieten
	public function downloadFile():Void
	{
		getURL (audio_source, "_self");
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//vorhandene infos generieren und anzeigen; aufruf durch clip im label 'showInfo'
	public function showInfo():Void
	{
		downloadLink_mc._visible=true;
		
		//ggf. textlink anzeigen
		if( audio_textLink!=undefined && audio_textLink!="" ){
			textLink_mc._visible=true;
		}
		
		//titel durchlaufen lassen
		generateTickerTitle();
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//vorhandene infos und buttons verbergen
	public function hideInfo():Void
	{
		downloadLink_mc._visible=false;
		textLink_mc._visible=false;
		ticker_txt.removeTextField();
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//titel in tickerform animieren
	public function generateTickerTitle():Void
	{
		//trace("generating: "+audio_title)
		
		this.createTextField( "ticker_txt", 1, 0, 0, 0, 0);
		ticker_txt.autoSize = true;
		ticker_txt.selectable = false;
		
		var _fmt = new TextFormat();
		_fmt.font = "Verdana";
		_fmt.size = 10;
		_fmt.color= 0x000000;
		
		ticker_txt.text=audio_title;
		ticker_txt.setTextFormat(_fmt);
		
		//text ausrichten
		ticker_txt._y = _height-ticker_txt._height;
		ticker_txt._x = this.INIT_WIDTH;
	
		//text animieren
		this.onEnterFrame=function(){
			ticker_txt._x--;
			if(ticker_txt._x < -ticker_txt._width)
				ticker_txt._x=this.INIT_WIDTH;
		};//oef
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//link auf externe datei generieren und anzeigen
	public function showText():Void
	{
		if(audio_javascriptFunction!=undefined && audio_textWinWidth!="")//js-function aufrufen, popup öffnen lassen
		{
			if( (audio_textWinWidth!=undefined && audio_textWinWidth!="") &&
		    	(audio_textWinHeight!=undefined && audio_textWinHeight!="") )
					getURL ("javascript:"+audio_javascriptFunction+"('"+audio_textLink+"' ,"+audio_textWinWidth+", "+audio_textWinHeight+")");
			else
				getURL ("javascript:"+audio_javascriptFunction+"('"+audio_textLink+"' ,"+TEXT_WIN_WIDTH+", "+TEXT_WIN_HEIGHT+")");
		}
		else//link in neuem browser-fenster öffnen
		{
			getURL (audio_textLink, "_blank");
		}
	};
	
}//class